# Uses of Interface
org.apache.avro.io.DatumReader

Packages that use DatumReader
Package
Description
org.apache.avro.data
Interfaces and base classes shared by generic, specific and reflect.
org.apache.avro.file
A container file for Avro data.
org.apache.avro.generic
A generic representation for Avro data.
org.apache.avro.io
Utilities for Encoding and Decoding Avro data.
org.apache.avro.reflect
Use Java reflection to generate schemas and protocols for existing classes.
org.apache.avro.specific
Generate specific Java classes for schemas and protocols.

## Uses of DatumReader in org.apache.avro.data

Classes in org.apache.avro.data that implement DatumReader
Modifier and Type
Class
Description
`static class`
`Json.ObjectReader`
`DatumReader` for arbitrary Json data using the object model described in `JsonProperties`.

## Uses of DatumReader in org.apache.avro.file

Methods in org.apache.avro.file with parameters of type DatumReader
Modifier and Type
Method
Description
`static <D> FileReader<D>`
DataFileReader.`openReader(File file, DatumReader<D> reader)`
Open a reader for a file.
`static <D> FileReader<D>`
DataFileReader.`openReader(SeekableInput in, DatumReader<D> reader)`
Open a reader for a file.
`static <D> DataFileReader<D>`
DataFileReader.`openReader(SeekableInput in, DatumReader<D> reader, DataFileStream.Header header, boolean sync)`
Construct a reader for a file at the current position of the input, without reading the header.
Constructors in org.apache.avro.file with parameters of type DatumReader
Modifier
Constructor
Description
``
`DataFileReader(File file, DatumReader<D> reader)`
Construct a reader for a file.
``
`DataFileReader(SeekableInput sin, DatumReader<D> reader)`
Construct a reader for a file.
`protected`
`DataFileReader(SeekableInput sin, DatumReader<D> reader, boolean closeOnError, byte[] magic)`
Construct a reader for a file.
`protected`
`DataFileReader(SeekableInput sin, DatumReader<D> reader, DataFileStream.Header header)`
Construct using a `DataFileStream.Header`.
``
`DataFileReader12(SeekableInput sin, DatumReader<D> reader)`
Construct a reader for a file.
``
`DataFileStream(InputStream in, DatumReader<D> reader)`
Construct a reader for an input stream.
`protected`
`DataFileStream(DatumReader<D> reader)`
create an uninitialized DataFileStream

## Uses of DatumReader in org.apache.avro.generic

Classes in org.apache.avro.generic that implement DatumReader
Modifier and Type
Class
Description
`class`
`GenericDatumReader<D>`
`DatumReader` for generic Java objects.
Methods in org.apache.avro.generic that return DatumReader
Modifier and Type
Method
Description
`DatumReader`
GenericData.`createDatumReader(Schema schema)`
Returns a `DatumReader` for this kind of data.
`DatumReader`
GenericData.`createDatumReader(Schema writer, Schema reader)`
Returns a `DatumReader` for this kind of data.

## Uses of DatumReader in org.apache.avro.io

Subinterfaces of DatumReader in org.apache.avro.io
Modifier and Type
Interface
Description
`static interface`
`FastReaderBuilder.FieldReader`
`static interface`
`FastReaderBuilder.ReusingFieldReader`
Classes in org.apache.avro.io that implement DatumReader
Modifier and Type
Class
Description
`static class`
`FastReaderBuilder.MapReader`
`static class`
`FastReaderBuilder.RecordReader`
Methods in org.apache.avro.io that return DatumReader
Modifier and Type
Method
Description
`<D> DatumReader<D>`
FastReaderBuilder.`createDatumReader(Schema schema)`
`<D> DatumReader<D>`
FastReaderBuilder.`createDatumReader(Schema writerSchema, Schema readerSchema)`

## Uses of DatumReader in org.apache.avro.reflect

Classes in org.apache.avro.reflect that implement DatumReader
Modifier and Type
Class
Description
`class`
`ReflectDatumReader<T>`
`DatumReader` for existing classes via Java reflection.
Methods in org.apache.avro.reflect that return DatumReader
Modifier and Type
Method
Description
`DatumReader`
ReflectData.`createDatumReader(Schema schema)`
`DatumReader`
ReflectData.`createDatumReader(Schema writer, Schema reader)`

## Uses of DatumReader in org.apache.avro.specific

Classes in org.apache.avro.specific that implement DatumReader
Modifier and Type
Class
Description
`class`
`SpecificDatumReader<T>`
`DatumReader` for generated Java classes.
Methods in org.apache.avro.specific that return DatumReader
Modifier and Type
Method
Description
`DatumReader`
SpecificData.`createDatumReader(Schema schema)`
`DatumReader`
SpecificData.`createDatumReader(Schema writer, Schema reader)`